//---------------------------------------------------------------------------
// ˵HMP-IIͼɼģͨЭʵֵĲο룬ȡԼ
// ߣ֧m
// 汾V1.0
//--------------------------------------------------------------------------- 

#include "rs232.h"

//---------------------------------------------------------------------------
void __fastcall TForm1::BtnControlClick(TObject *Sender)
{
    DWORD   count;

    if(!RS232Open(UartPort->Text, StrToInt(UartBaud->Text)))
    {
        ShowStatus("ͨʧܣ鴮Ƿڻռ");
        return;
    }
    Buf[0] = UART_FLAG1;
    Buf[1] = UART_FLAG2;
    Buf[2] = UART_CONTROL;
    Buf[3] = 0x01;
    switch(ComboCmd->ItemIndex)
    {
        case 0:
            Buf[4] = ComboCmd->ItemIndex;
            break;
        case 8:
            Buf[4] = 0xF0;
            break;
        case 9:
            Buf[4] = 0xFF;
            break;
        default:
            Buf[4] = ComboCmd->ItemIndex;
            if(ComboType->ItemIndex==0)
            {
                count = StrToInt(UartBaud->Items->Strings[Buf[4]-1]);
                if(!RS232Baud(count))
                {
                    RS232Close();
                    ShowStatus("ͨʧܣǰڲ֧ѡͨ");
                    return;
                }
                RS232Baud(StrToInt(UartBaud->Text));
            }
            else
            {
                RS232Close();
                ShowStatus("ϵͳʧܣǰӿͲ֧ͨ");
                return;
            }
    }

    MemoAdd("ϵͳ", 0, Buf);
    if(RS232Send(Buf,Buf[3]+5))
    {
        MemoAdd("ͣ", Buf[3]+5, Buf);
        count = RS232Recieve(Buf, RS232TIMEBYTE*2, RS232TIMEBYTE);
        if((count>0)&&(Buf[2]==UART_CONTROL))
        {
            MemoAdd("գ", Buf[3]+5, Buf);
            if((Buf[4]>0)&&(Buf[4]<8)&&((Buf[4]-1)!=UartBaud->ItemIndex))
            {
                UartBaud->ItemIndex = Buf[4] - 1;
                RS232Baud(StrToInt(UartBaud->Text));
            }
            ShowStatus("ϵͳɹ鿴ͨݼ¼ԻøϢ");
        }
        else
        {
            ShowStatus("ϵͳʧܣӦʧ");
        }
    }
    else
    {
        ShowStatus("ϵͳʧܣʧ");
    }
    RS232Close();
    MemoAdd("", 0, Buf);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::BtnConfigClick(TObject *Sender)
{
    DWORD   count;
    int     bright,contrast,saturation,hue,row,column;

    if((!TryStrToInt(EditBright->Text,bright))||
       (!TryStrToInt(EditContrast->Text,contrast))||
       (!TryStrToInt(EditSaturation->Text,saturation))||
       (!TryStrToInt(EditHue->Text,hue))||
       (!TryStrToInt(EditRow->Text,row))||
       (!TryStrToInt(EditColumn->Text,column)))
    {
        ShowStatus("ʧܣȡԱȶȵȲϷֵ");
        return;
    }
    if((bright<0)||(bright>127)||
       (contrast<0)||(contrast>127)||
       (saturation<0)||(saturation>127)||
       (hue<0)||(hue>127)||
       (row<0)||(row>32)||
       (column<0)||(column>32))
    {
        ShowStatus("ʧܣȡԱȶȵȲϷֵ");
        return;
    }

    if(!RS232Open(UartPort->Text, StrToInt(UartBaud->Text)))
    {
        ShowStatus("ͨʧܣ鴮Ƿڻռ");
        return;
    }

    Buf[0] = UART_FLAG1;
    Buf[1] = UART_FLAG2;
    Buf[2] = UART_CONFIG;
    Buf[3] = 0x07;
    Buf[4] = bright;
    Buf[5] = contrast;
    Buf[6] = saturation;
    Buf[7] = hue;
    Buf[8] = row;
    Buf[9] = column;
    Buf[10] = ComboColor->ItemIndex + ComboPosition->ItemIndex*8; 
    MemoAdd("", 0, Buf);
    if(RS232Send(Buf,Buf[3]+5))
    {
        MemoAdd("ͣ", Buf[3]+5, Buf);
        count = RS232Recieve(Buf, RS232TIMEBYTE*2, RS232TIMEBYTE);
        if((count>0)&&(Buf[2]==UART_CONFIG))
        {
            MemoAdd("գ", Buf[3]+5, Buf);
            ShowStatus("ɹ鿴ͨݼ¼ԻøϢ");
        }
        else
        {
            ShowStatus("ʧܣӦʧ");
        }
    }
    else
    {
        ShowStatus("ʧܣʧ");
    }
    RS232Close();
    MemoAdd("", 0, Buf);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::BtnDatetimeClick(TObject *Sender)
{
    DWORD   count;
    unsigned short year,month,day,hour,minute,second,ms;
    TDateTime datetime;

    if(!RS232Open(UartPort->Text, StrToInt(UartBaud->Text)))
    {
        ShowStatus("ͨʧܣ鴮Ƿڻռ");
        return;
    }

    datetime = Now();
    datetime.DecodeDate(&year,&month,&day);
    datetime.DecodeTime(&hour,&minute,&second,&ms);
    Buf[0] = UART_FLAG1;
    Buf[1] = UART_FLAG2;
    Buf[2] = UART_DATETIME;
    Buf[3] = 0x06;
    Buf[4] = year - 2000;
    Buf[5] = month;
    Buf[6] = day;
    Buf[7] = hour;
    Buf[8] = minute;
    Buf[9] = second;
    MemoAdd("ʱ", 0, Buf);
    if(RS232Send(Buf,Buf[3]+5))
    {
        MemoAdd("ͣ", Buf[3]+5, Buf);
        count = RS232Recieve(Buf, RS232TIMEBYTE*2, RS232TIMEBYTE);
        if((count>0)&&(Buf[2]==UART_DATETIME))
        {
            MemoAdd("գ", Buf[3]+5, Buf);
            ShowStatus("ʱɹ鿴ͨݼ¼ԻøϢ");
        }
        else
        {
            ShowStatus("ʱʧܣӦʧ");
        }
    }
    else
    {
        ShowStatus("ʱʧܣʧ");
    }
    RS232Close();
    MemoAdd("", 0, Buf);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::BtnUserClick(TObject *Sender)
{
    DWORD   count;

    if(EditUser->Text.Length()!=16)
    {
        ShowStatus("ûַʧܣ16ַ㲿ÿո");
        return;
    }
    for(int i=0;i<16;i++)
    {
        Buf[4+i] = (unsigned char)(*(EditUser->Text.c_str()+i));
        if((Buf[4+i]<0x20)||(Buf[4+i]>0x6F))
        {
            ShowStatus("ûַʧܣڲϷַַ뷶ΧΪ0x200x6F");
            return;
        }
    }

    if(!RS232Open(UartPort->Text, StrToInt(UartBaud->Text)))
    {
        ShowStatus("ͨʧܣ鴮Ƿڻռ");
        return;
    }

    Buf[0] = UART_FLAG1;
    Buf[1] = UART_FLAG2;
    Buf[2] = UART_USER;
    Buf[3] = 0x10;
    MemoAdd("ûַ", 0, Buf);
    if(RS232Send(Buf,Buf[3]+5))
    {
        MemoAdd("ͣ", Buf[3]+5, Buf);
        count = RS232Recieve(Buf, RS232TIMEBYTE*2, RS232TIMEBYTE);
        if((count>0)&&(Buf[2]==UART_USER))
        {
            MemoAdd("գ", Buf[3]+5, Buf);
            ShowStatus("ûַɹ鿴ͨݼ¼ԻøϢ");
        }
        else
        {
            ShowStatus("ûַʧܣӦʧ");
        }
    }
    else
    {
        ShowStatus("ûַʧܣʧ");
    }
    RS232Close();
    MemoAdd("", 0, Buf);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::BtnSingleClick(TObject *Sender)
{
    DWORD   count;
    int filehandle;
    unsigned int total,next,number;
    TDateTime datetime;
    AnsiString  string;

    LabelImage->Caption = "ͼ";
    Image->Visible = false;
    datetime = Now();     
    if(CheckCatch->Checked)
    {
        if(CheckCompress->Checked)                              // ȲɼѹJPEG
        {
            string = datetime.FormatString("yyyymmdd_hhnnss_") + "²ɼѹ_" + ComboChanel->Text + "_" + ComboSize->Text + "_" + LabelLevel->Caption + ".jpg";
        }
        else                                                    // ֻɼѹyuv
        {
            string = datetime.FormatString("yyyymmdd_hhnnss_") + "²ɼѹ_" + ComboChanel->Text + ".bin";
        }
    }
    else
    {
        if(CheckCompress->Checked)                              // ɼѹJPEG
        {
            string = datetime.FormatString("yyyymmdd_hhnnss_") + "ɲɼѹ_" + ComboSize->Text + "_" + LabelLevel->Caption + ".jpg";
        }
        else                                                    // ɼѹJPEG
        {
            string = datetime.FormatString("yyyymmdd_hhnnss_") + "ɲɼѹ.jpg";
        }
    }
    filehandle = FileCreate(CurDir+"Picture\\"+string);
    if(filehandle<1)
    {
        ShowStatus("ͼɼʧܣͼļʧ");
        return;
    }
    FileClose(filehandle);

    if(!RS232Open(UartPort->Text, StrToInt(UartBaud->Text)))
    {
        FileDirDelete(CurDir+"Picture\\"+string, false);
        ShowStatus("ͨʧܣ鴮Ƿڻռ");
        return;
    }

    Buf[0] = UART_FLAG1;
    Buf[1] = UART_FLAG2;
    Buf[2] = UART_IMAGE;
    Buf[3] = 0x02;
    Buf[4] = ComboChanel->ItemIndex;
    if(CheckCatch->Checked)
    {
        Buf[4] |= 0x04;
    }

    Buf[5] = ScrollBarLevel->Position;
    Buf[5] |= ComboSize->ItemIndex << 3;
    if(CheckDatetime->Checked)
    {
        Buf[5] |= 0x10;
    }
    if(CheckUser->Checked)
    {
        Buf[5] |= 0x20;
    }
    if(CheckCompress->Checked)
    {
        Buf[5] |= 0x40;
    }
    MemoAdd("ͼɼ", 0, Buf);
    if(RS232Send(Buf,Buf[3]+5))
    {
        MemoAdd("ͣ", Buf[3]+5, Buf);
        count = RS232Recieve(Buf, RS232TIMEFRAME, RS232TIMEBYTE);
        if((count>0)&&(Buf[2]==UART_IMAGE))
        {
            total = Buf[4];
            total *= 256;
            total += Buf[5];
            if(total==0)                                                    // ݻ
            {
                FileDirDelete(CurDir+"Picture\\"+string, false);
                MemoAdd("գ", Buf[3]+5, Buf);
                if(Buf[7]==2)
                    ShowStatus("ͼɼʧܣݲɼJPEGѹʧܣͼ");
                else
                    ShowStatus("ͼɼɹ鿴ͨݼ¼ԻøϢ");
            }
            else                                                            // ݣJPEGYUV
            {
                filehandle = FileOpen(CurDir+"Picture\\"+string, fmOpenReadWrite);
                next = 1;
                while(1)
                {
                    number = Buf[6];
                    number *= 256;
                    number += Buf[7];
                    if(number==next)
                    {
                        FileWrite(filehandle,Buf+8,Buf[3]-4);
                        next += 1;
                    }
                    if(number==total)
                        break;
                    count = RS232Recieve(Buf, RS232TIMEFRAME, RS232TIMEBYTE);
                    if((count==0)||(Buf[2]!=UART_IMAGE))
                        break;
                }
                FileSeek(filehandle,0,0);
                FileRead(filehandle,Buf,2);
                FileSeek(filehandle,-2,2);
                FileRead(filehandle,Buf+2,2);
                FileClose(filehandle);
                if(number!=total)
                {
                    MemoAdd("գͼļ " + string + " ʧ", 0, Buf);
                    ShowStatus("ͼɼʧܣѽ֡֡һ");
                }
                else if(CheckCatch->Checked && (!CheckCompress->Checked))   // ϴԭʼɼݣڲƷ׶
                {
                    LabelImage->Caption = string;
                    Image->Visible = false;
                    MemoAdd("գͼļ " + string + " ɹ", 0, Buf);
                    ShowStatus("ͼɼɹ鿴ͨݼ¼ԻøϢ");
                }
                else if((Buf[0]==0xFF)&&(Buf[1]==0xD8)&&(Buf[2]==0xFF)&&(Buf[3]==0xD9))
                {
                    LabelImage->Caption = string;
                    Image->Picture->LoadFromFile(CurDir+"Picture\\"+string);
                    Image->Visible = true;                   
                    MemoAdd("գͼļ " + string + " ɹ", 0, Buf);
                    ShowStatus("ͼɼɹ鿴ͨݼ¼ԻøϢ");
                }
                else
                {
                    LabelImage->Caption = string;
                    Image->Visible = false;
                    MemoAdd("գͼļ " + string + " ɹǺϷJPEGļ", 0, Buf);
                    ShowStatus("ͼɼɹ鿴ͨݼ¼ԻøϢ");
                }
            }
        }
        else
        {
            FileDirDelete(CurDir+"Picture\\"+string, false);
            ShowStatus("ͼɼʧܣӦʧ");
        }
    }
    else
    {
        FileDirDelete(CurDir+"Picture\\"+string, false);
        ShowStatus("ͼɼʧܣʧ");
    }
    RS232Close();
    MemoAdd("", 0, Buf);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::BtnFontClick(TObject *Sender)
{
    unsigned char buf[256],code;
    DWORD   count;

    for(int i=0;i<16;i++)                                                   // 16ַ
    {
        for(int j=0;j<16;j++)
        {
            buf[i*16+j] = 0;
            for(int k=0;k<8;k++)
            {
                if(ImageFont->Picture->Bitmap->Canvas->Pixels[(i&7)*8+k][(i/8)*16+j]==0x00000000)
                {
                    buf[i*16+j] |= 1 << (7-k);   
                }
            }
        }
    }

    if(!RS232Open(UartPort->Text, StrToInt(UartBaud->Text)))
    {
        ShowStatus("ͨʧܣ鴮Ƿڻռ");
        return;
    }

    code = 0x60;
    MemoAdd("ûֿ", 0, Buf);
    for(int i=0;i<16;i++)                                               // 16ûֿ
    {
        Buf[0] = UART_FLAG1;
        Buf[1] = UART_FLAG2;
        Buf[2] = UART_FONT;
        Buf[3] = 0x11;
        Buf[4] = code;
        for(int j=0;j<16;j++)
            Buf[5+j] = buf[i*16+j];
        if(RS232Send(Buf,Buf[3]+5))
        {
            MemoAdd("ͣ", Buf[3]+5, Buf);
            count = RS232Recieve(Buf, RS232TIMEBYTE*2, RS232TIMEBYTE);
            if((count>0)&&(Buf[2]==UART_FONT))
            {
                MemoAdd("գ", Buf[3]+5, Buf);
                ShowStatus("ûֿɹ鿴ͨݼ¼ԻøϢ");
            }
            else
            {
                ShowStatus("ûֿʧܣӦʧ");
                break;
            }
        }
        else
        {
            ShowStatus("ûֿʧܣʧ");
            break;
        }
        code += 1;
    }
    RS232Close();
    MemoAdd("", 0, Buf);
}

